<script lang="ts">
  import CardBack from "./CardBack.svelte";
  import EmptyCardSpot from "./EmptyCardSpot.svelte";
  import CardFront from "./CardFront.svelte";

  export let deck: Card[];
  export let reverse: boolean = false;
  export let faceDown: boolean = false;

  $: size = deck.length;
  $: renderedSize = Math.min(size, 5);

  let cards: Card[];
  $: {
    cards = deck.slice(0, renderedSize);
    if (reverse) {
      cards.reverse();
    }
  }
</script>

<div class="deck">
  {#if renderedSize === 0}
    <div>
      <EmptyCardSpot />
    </div>
  {/if}
  {#each cards as card, idx (card)}
    <div style={`transform: translate(-${idx * 0.3}em, -${idx * 0.3}em);`}>
      {#if faceDown}
        <CardBack {card} />
      {:else}
        <CardFront {card} />
      {/if}
    </div>
  {/each}
</div>

<style>
  .deck {
    position: relative;
  }
  .deck > *:first-child {
    position: relative;
    height: 14em;
  }
  .deck > * {
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
  }
</style>
